#include "alloc.h"
#include "error.h"
#include "gc.h"

#include <string.h>

static int alloc_cnt;

void *xmalloc( size_t size )
{
	void *ptr = pceHeapAlloc( size );
	alloc_cnt++;
	if ( ptr == NULL ) {
		gc();
		ptr = pceHeapAlloc( size );
		if ( ptr == NULL )
			fetal_error("alloc failed.");
	}
	return ptr;
}

void *xcalloc( size_t size, size_t elem )
{
	void *ptr = xmalloc( size*elem );
	memset( ptr, 0, size*elem );
	return ptr;
}

void xfree( void *ptr )
{
	pceHeapFree(ptr);
	alloc_cnt--;
}
