#ifndef __class_h__
#define __class_h__

#include "type.h"
#include "util.h"

#include "method.h"

struct field_bucket
{
	void *name;
	int offset;
};


struct const_pool
{
	u2 type;
	u2 val2;
	u4 val1;
};

struct jclass
{
	struct jclass *parent;

	const char *classname;

	int pool_num;
	struct const_pool *constants;

	struct field_bucket *static_field;
	struct field_bucket *instance_field;

	/* static $BJQ?t$NJ*BN(B */
	jvalue *class_field_val;

	int static_field_num;
	int instance_field_num;

	int field_size;

	int smeth_cnt;
	int imeth_cnt;

	struct method_header *static_method;
	struct method_header *instance_method;

	struct method_header **vtbl;
	int vtbl_size;

	/* $B%O%C%7%eMQ(B */
	struct jclass *next;
};

#define STRING_CONST(cls,index) ((char*)(cls->constants[index].val1))

/* (II)I $B$H$+$f!<(Bdescriptor$B$N0z?t$N?t$r?t$($k(B */
int compute_argnum( const char *desc );

/* $B%/%i%9%F!<%V%k$KEPO?(B */
void register_class(struct jclass * );
/* $B%/%i%9%F!<%V%k$+$i<h$C$F$/$k(B
 * $B%F!<%V%k$K$J$+$C$?$i%m!<%I!%(B
 */
struct jclass *get_class( const char *clsname );


enum {
	ACC_PUBLIC=1,
	ACC_PRIVATE=1<<1,
	ACC_PROTECTED=1<<2,
	ACC_STATIC=1<<3,
	ACC_FINAL=1<<4,
	ACC_VOLATILE=1<<5,
	ACC_TRANSIENT=1<<6,
};	


struct method_header *get_static_method( struct jclass *, const char *name, const char *desc );

enum {
	GET_METHOD_VIRTUAL,
	GET_METHOD_SPECIAL
};
struct method_header *get_method( struct jclass*,
				  const char *name, const char *desc,
				  int mode );

/* $B%M%$%F%#%V%/%i%9$NEPO?(B */
void init_class_table();

#endif
