#include <piece.h>
#include "readbuf.h"
#include "class.h"
#include "instance.h"
#include "execute.h"
#include "array.h"
#include "error.h"
#include "gc.h"
#include "alloc.h"
#include "zip.h"

#ifdef NATIVE
int errno;
#endif

static struct gcpro mainpro;
static struct jinstance *mainobj;
static struct jclass *mainclass;
static struct method_header *proc_method;

struct zipfile default_jar;

void pceAppInit()
{
	struct method_header *init_method;
	pceLCDDispStart();

	// usb_dbginit();
	init_gc();
	
	if ( setjmp( errorjmp ) != 0 )
		return;

	if ( zip_open( &default_jar, "main.jar" )!=0 ) {
		fetal_error("main.jar $B$,L5$$(B");
		return;
	}

	init_class_table();

	pceAppSetProcPeriod( 1000/30 );

	mainclass = get_class("Main");

	if ( mainclass == NULL )
		goto error;

	mainobj = new_instance( mainclass );

	mainpro.next = NULL;
	mainpro.obj = (struct object_header*)mainobj;
	protect_list = &mainpro;

	init_method = get_method( mainclass, "<init>", "()V", GET_METHOD_SPECIAL );

	if ( init_method == NULL )
		goto error;

	proc_method = get_method( mainclass, "appProc", "(I)V", GET_METHOD_SPECIAL );


	if ( proc_method == NULL )
		goto error;

	current_class = mainclass;
	current_method = init_method;

	ip = init_method->code;

	fp = sp+1;
	PUSH( mainobj );
	sp += init_method->max_local;

	PUSH( NULL );
	PUSH( init_method );
	PUSH( NULL );

	execute();
	pceLCDDispStart();

	return;

error:
	errormes = "can't find main\n";
}

static void disperror()
{
	if ( pcePadGet() & TRG_A )
		pceAppReqExit( 0 );
}

void pceAppProc( int cnt )
{
	setjmp( errorjmp );

	if ( errormes != 0 ) {
		disperror();
		return;
	}

	current_class = mainclass;
	current_method = proc_method;

	ip = proc_method->code;
	fp = sp+1;
	PUSH( mainobj );
	PUSH( cnt );
	sp += proc_method->max_local;

	PUSH( NULL );
	PUSH( proc_method );
	PUSH( NULL );

	execute();

	fp = sp = op_stack;
}

void pceAppExit()
{}
