#ifndef __NATIVE_H_
#define __NATIVE_H_

#include <string.h>
#include <stdlib.h>
#include "method.h"
#include "util.h"

#define NATIVE_METHOD(name,desc,argnum,is_retval,func,ofclass,offset) { NULL, func, name,desc,0,argnum,1,\
	is_retval,ofclass,offset}

static inline void init_native_vtbl( struct method_header **vtbl, struct method_header **parent_vtbl,
			 int parent_vtblcnt,
			 struct method_header *methods, int method_cnt )
{
	int i;
	memcpy( vtbl, parent_vtbl, sizeof(struct method_header*)*parent_vtblcnt );
	
	for ( i=0; i<method_cnt; i++ ) {
		vtbl[i+parent_vtblcnt] = &methods[i];
	}
}

#define NATIVE_CLASS(parent,name,sfield,ifield,sfieldval,instance_size,smeth,imeth,vtbl) \
{parent,name,0,NULL,sfield,ifield,sfieldval,NELEM(sfield),NELEM(ifield),instance_size,\
 NELEM(smeth),NELEM(imeth),smeth,imeth,vtbl,NELEM(vtbl),NULL}

#define NATIVE_CLASS_NOSTATIC(parent,name,field_info,field_cnt,method,vtbl) \
NATIVE_CLASS(parent,name,NULL,field_info,NULL,field_cnt,NULL,method,vtbl)

#endif 
