#include <stdlib.h>
#include <string.h>

#include "piece.h"
#include "execute.h"
#include "instance.h"
#include "jobject.h"
#include "array.h"
#include "native.h"
#include "gc.h"
#include "piece_bmp.h"

#include <piece.h>

static struct jclass piece;

static struct gcpro vbuffpro;
struct array_head *vbuff;

static void lcdtrans()
{
	pceLCDTrans();
}

/* byte[] lcdSetBuffer([B) */
static void lcd_setbuffer()
{
	struct array_head *oldval = vbuff;
	struct array_head *arg = (struct array_head*)sp[0];

	if ( arg != 0 ) {
		vbuff = arg;
		vbuffpro.obj = (struct object_header*)vbuff;
		pceLCDSetBuffer( (unsigned char *)(arg->field) );
	}

	retval = (jvalue)oldval;
}

DRAW_OBJECT drawobj;

/* void drawBmp(Lvaca/PieceBmp;II) */
static void drawBmp()
{
	struct jinstance *ibmp = INSTANCE(sp[-2]);
	int x = sp[-1];
	int y = sp[0];
	PIECE_BMP bmp;

	piece_bmp_to_PIECE_BMP( ibmp, &bmp );

	pceLCDSetObject( &drawobj, &bmp, x, y, 0, 0, bmp.header.w, bmp.header.h, DRW_NOMAL );
	pceLCDDrawObject( drawobj );
}

static void pad_get()
{
	retval = pcePadGet();
}

static void cls()
{
	memset ( vbuff->field, 0, 128*88 );
}

static void app_req_exit()
{
	jvalue code = sp[0];
	pceAppReqExit((int)code);
}

static struct method_header methods[] = {

	NATIVE_METHOD("lcdTrans","()V",0,0,lcdtrans,&piece, 0),
	NATIVE_METHOD("lcdSetBuffer","([B)[B",1,1,lcd_setbuffer,&piece,1),
	NATIVE_METHOD("padGet","()I",0,1,pad_get, &piece, 2),
	NATIVE_METHOD("cls","()V",0,0,cls,&piece, 3),
	NATIVE_METHOD("appReqExit","(I)V",1,0,app_req_exit,&piece, 4),
	NATIVE_METHOD("drawBmp","(Lvaca/PieceBmp;II)V",3,0,drawBmp,&piece,5),

};

static struct jclass piece =
NATIVE_CLASS( &javalangObject, "vaca/Piece", NULL, NULL, NULL, 0,
	      methods, NULL, jobjectvtbl );

struct jclass *new_piece_class()
{
	vbuff = new_array( 128*88, BYTE_ARRAY );
	pceLCDSetBuffer( (unsigned char*)(vbuff->field) );

	vbuffpro.next = protect_list;
	vbuffpro.obj = (struct object_header*)vbuff;
	protect_list = &vbuffpro;

	return &piece;
}
	
