#ifndef __readbuf_h__
#define __readbuf_h__

#include "type.h"

#ifdef USE_PIECE

#include "readbuf_pce.h"
#include "zip.h"

#else

#include <stdio.h>
typedef FILE READ_BUF;

#endif

u4 read_u4( READ_BUF *bufp );
u2 read_u2( READ_BUF *bufp );

#ifdef USE_PIECE

u1 read_u1( READ_BUF *bufp );
size_t buf_tell( READ_BUF *bufp );
void buf_setpos( READ_BUF *bufp, size_t offset );
void buf_seek( READ_BUF *bufp, size_t offset );

void read_buf( READ_BUF *buf, size_t size, void *buffer );
READ_BUF *readbuf_open( const char *fname );
void readbuf_close( READ_BUF *buf );

extern struct zipfile default_jar;

#else

#define read_u1(f) (getc(f))
#define read_buf(readbuf,size,buf) ( fread((buf), 1, (size), (readbuf) ) )

#define buf_tell(buf) ( ftell(buf) )
#define buf_setpos(buf,offset) ( fseek( buf, offset, SEEK_SET ) )
#define buf_seek(buf,offset) ( (fseek( buf, offset, SEEK_CUR ) )

#define readbuf_open(fname) ( fopen(fname,"r") )
#define readbuf_close(fp) ( fclose(fp) )

#endif

#endif // readbuf_h
