#include "resolve.h"
#include "pool.h"
#include <string.h>

static void resolve_class( struct jclass *cls )
{
	int i;
	
	for ( i=0; i<cls->pool_num; i++ ) {
		if ( cls->constants[i].type == tag_CLASS ) {
			const char *name = STRING_CONST( cls, cls->constants[i].val1 );
			if ( *name != '[' ) {
				struct jclass *c = get_class(name);
				cls->constants[i].val1 = (long)c;
			}
		}
	}
}

static struct field_bucket *get_fieldinner( struct field_bucket *f, int num, const char*name )
{
	int i;

	for ( i=0; i<num; i++ ) {
		if ( strcmp(f->name, name) == 0 )
			return f;
		f++;
	}
	return NULL;
}

static struct field_bucket *get_field( struct jclass *cls, const char *name )
{
	struct field_bucket *f = get_fieldinner( cls->static_field, cls->static_field_num,name );
	if ( f==NULL )
		return get_fieldinner( cls->instance_field, cls->instance_field_num, name );
	return f;
}

/* val1 16: class 
 * val2 16: name  ->
 *  
 *   val1 32: pointer to jclass
 *   val2 16: field offset
 */
static void resolve_field( struct jclass *cls, int index )
{
	struct jclass *c = (struct jclass*)cls->constants[cls->constants[index].val1].val1;
	int nntidx = cls->constants[index].val2;
	const char *name = STRING_CONST( cls, cls->constants[nntidx].val1 );

	struct field_bucket *f = get_field( c, name );

	cls->constants[index].val1 = (long)c;
	cls->constants[index].val2 = f->offset;
}

void resolve_constant( struct jclass *cls )
{
	int i;
	resolve_class(cls);
	for ( i=1; i< cls->pool_num; i++ ) {
		switch( cls->constants[i].type ) {
		case tag_FIELDREF:
			resolve_field( cls, i);
		}
	}
}
