#include "class.h"
#include "loader.h"
#include "util.h"
#include "jobject.h"
#include "execute.h"
#include "array.h"
#include "instance.h"

int main(int argc, char **argv)
{
	struct jclass *c;
	struct method_list *mainmeth;

	if ( argc<2 ) {
		printf("usage: %s class_name\n", argv[0]);
		return 1;
	}

	init_instance();
	init_array();
	init_class_table();

	c = get_class(argv[1]);
	mainmeth = get_static_method( c, "main", "([Ljava/lang/String;)V" );

	current_class = c;
	current_method = mainmeth;
	ip = mainmeth->code;

	push(NULL);
	fp = sp+1;
	sp += mainmeth->max_local;

	push(mainmeth);
	push(NULL);

	execute();

	return 0;
}
